Bug 840050 - Review Request: python26-cheetah - Template engine and code-generator
Review Request: python26-cheetah - Template engine and code-generator
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ricardo Rocha
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-13 10:55 EDT by Steve Traylen
Modified: 2012-08-05 02:41 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-05 02:41:07 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
rocha.porto: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Steve Traylen 2012-07-13 10:55:45 EDT
Spec URL: http://cern.ch/straylen/rpms/python26-cheetah/python26-cheetah.spec
SRPM URL: http://cern.ch/straylen/rpms/python26-cheetah/python26-cheetah-2.4.4-2.el5.centos.src.rpm
Description: Template engine and code-generator
Fedora Account System Username: stevetraylen

This is an EPEL 5 package only for python26.

Steve.
Comment 1 Ricardo Rocha 2012-07-13 13:17:03 EDT
Hi.

Here's a first go at it.

Generic things:

- what about replacing (not to have it hardcoded):
%global python_sitearch %{_libdir}/python2.6/site-packages

with something like:

%global pybasever 2.6
%global __python /usr/bin/python%{pybasever}

%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}


 +:ok, =:needs attention, -:needs fixing

MUST Items:
[-] MUST: rpmlint must be run on every package.

python26-cheetah.x86_64: W: incoherent-version-in-changelog 2.0.1-2 ['2.4.4-2.el5.centos', '2.4.4-2.centos']

- could you fix this?

python26-cheetah.x86_64: W: unstripped-binary-or-object /usr/lib64/python2.6/site-packages/Cheetah/_namemapper.so

- please add the executable flag to this one

python26-cheetah-debuginfo.x86_64: E: empty-debuginfo-package

- this is fine, as you can't make it noarch

3 packages and 0 specfiles checked; 1 errors, 2 warnings.

[+] MUST: The package must be named according to the Package Naming Guidelines.
Follows the rest of the python26-* packages.
[+] MUST: The spec file name must match the base package %{name}
[+] MUST: The package must be licensed with a Fedora approved license and meet
the Licensing Guidelines.
MIT.
[-] MUST: The License field in the package spec file must match the actual
license.

The LICENSE file does not mention any specific license, the PKG-INFO file then has:
...
License: UNKNOWN
...
Classifier: License :: OSI Approved :: MIT License
...

so it looks like MIT, but is it sure and could it be more explicit?

[-] MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.

The source contains a LICENSE file and you include it, but the text does not match the MIT license text i could find.

[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source,
as provided in the spec URL.
# md5sum Cheetah-2.4.4.tar.gz*
853917116e731afbc8c8a43c37e6ddba  Cheetah-2.4.4.tar.gz
853917116e731afbc8c8a43c37e6ddba  Cheetah-2.4.4.tar.gz.srcrpm
[+] MUST: The package must successfully compile and build into binary rpms on
at least one supported architecture.
Targeted only at EPEL5, works.
[+] MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires
[+] MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro.
Not used.
[+] MUST: Every binary RPM package which stores shared library files (not just
symlinks) in any of the dynamic linker's default paths, must call ldconfig in
%post and %postun.
Package has a _namemapper.so, but not in a default path.
[+] MUST: If the package is designed to be relocatable, the packager must state
this fact in the request for review
[+] MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory.
[+] MUST: A package must not contain any duplicate files in the %files listing.
[-] MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include a
%defattr(...) line.

Missing executable flag in _namemapper.so.

[+] MUST: Each package must have a %clean section, which contains rm -rf
%{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: Each package must consistently use macros, as described in the macros
section of Packaging Guidelines.
[+] MUST: The package must contain code, or permissible content. This is
described in detail in the code vs. content section of Packaging Guidelines.
[+] MUST: Large documentation files should go in a doc subpackage.
Not the case.
[+] MUST: If a package includes something as %doc, it must not affect the
runtime of the application.
[+] MUST: Header files must be in a -devel package.
No header files.
[+] MUST: Static libraries must be in a -static package.
No static libraries.
[+] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'
(for directory ownership and usability).
No pkgconfig.
[+] MUST: If a package contains library files with a suffix (e.g.
libfoo.so.1.1), then library files that end in .so (without suffix) must go in
a -devel package.
Only _namemapper.so is provided.
[+] MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release} 
No -devel.
[+] MUST: Packages must NOT contain any .la libtool archives, these should be
removed in the spec.
[+] MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in the
%install section.
No GUI.
[+] MUST: Packages must not own files or directories already owned by other
packages.
[+] MUST: At the beginning of %install, each package MUST run rm -rf
%{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD Items:
[+] SHOULD: If the source package does not include license text(s) as a
separate file from upstream, the packager SHOULD query upstream to include it.
[+] SHOULD: The description and summary sections in the package spec file
should contain translations for supported Non-English languages, if available.
English is ok, add others if you want.
[+] SHOULD: The reviewer should test that the package builds in mock.
[+] SHOULD: The package should compile and build into binary rpms on all
supported architectures.
http://koji.fedoraproject.org/koji/taskinfo?taskID=4238642
[+] SHOULD: The reviewer should test that the package functions as
described.
At least it installs.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane.
[+] SHOULD: Usually, subpackages other than devel should require the base
package using a fully versioned dependency.

Additional python checks:
[+] MUST: Python eggs must be built from source. They cannot simply drop an egg from upstream into the proper directory. (See prebuilt binaries Guidelines for details)
The sources do provide an egginfo directory, but it's not the one being packaged.
[+] MUST: Python eggs must not download any dependencies during the build process.
[+] MUST: When building a compat package, it must install using easy_install -m so it won't conflict with the main package.
Not a multi-version package.
[+] MUST: When building multiple versions (for a compat package) one of the packages must contain a default version that is usable via "import MODULE" with no prior setup.
Not a multi-version package.
[+] SHOULD: A package which is used by another package via an egg interface should provide egg info.
egginfo available.
Comment 2 Steve Traylen 2012-07-13 14:40:40 EDT
(In reply to comment #1)
> Generic things:
> 
> - what about replacing (not to have it hardcoded):
> %global python_sitearch %{_libdir}/python2.6/site-packages
> 
> with something like:
> 
> %global pybasever 2.6
> %global __python /usr/bin/python%{pybasever}
> 
> %{!?python_sitearch: %global python_sitearch %(%{__python} -c "from
> distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
> 
> 

I will do if you like but I always  think given the the package
is completely hardcoded to EPEL5 anyway it makes little difference
to make the variables also hardcoded.

If you do make them dynamic utilizing python2.6 within these
%globals then you get non fatal koji errors when the .src.rpm is created
which is ugly. 

Essentially other people have made me go from 
dynamic to static in exactly the same case.

>  +:ok, =:needs attention, -:needs fixing
> 
> MUST Items:
> [-] MUST: rpmlint must be run on every package.
> 
> python26-cheetah.x86_64: W: incoherent-version-in-changelog 2.0.1-2
> ['2.4.4-2.el5.centos', '2.4.4-2.centos']

Agreed, fixed in next package.
 
> python26-cheetah.x86_64: W: unstripped-binary-or-object
> /usr/lib64/python2.6/site-packages/Cheetah/_namemapper.so
> - please add the executable flag to this one

Agreed, I even changed it away from that for some reason. Fixed.

> [-] MUST: The License field in the package spec file must match the actual
> license.
> 
> The LICENSE file does not mention any specific license, the PKG-INFO file
> then has:
> ...
> License: UNKNOWN
> ...
> Classifier: License :: OSI Approved :: MIT License
> ...
> 
> so it looks like MIT, but is it sure and could it be more explicit?

The LICENSE file is in essence a combination of MIT license as documented here

https://fedoraproject.org/wiki/Licensing/MIT

I feel this qualifies as MIT.

> [-] MUST: If (and only if) the source package includes the text of the
> license(s) in its own file, then that file, containing the text of the
> license(s) for the package must be included in %doc.
> 
> The source contains a LICENSE file and you include it, but the text does not
> match the MIT license text i could find.
> 

Same point as above.

> [-] MUST: Permissions on files must be set properly. Executables should be
> set
> with executable permissions, for example. Every %files section must include a
> %defattr(...) line.
> 
> Missing executable flag in _namemapper.so.
> 

Corrected

Fresh packages:

http://cern.ch/straylen/rpms/python26-cheetah/python26-cheetah.spec
http://cern.ch/straylen/rpms/python26-cheetah/python26-cheetah-2.4.4-2.el5.src.rpm
Comment 4 Ricardo Rocha 2012-07-16 03:32:18 EDT
All comments have been taken into account.

APPROVED!
Comment 5 Steve Traylen 2012-07-16 04:23:29 EDT
New Package SCM Request
=======================
Package Name: python26-cheetah
Short Description: Template engine and code-generator
Owners: stevetraylen
Branches: el5
InitialCC:

Thanks for the review, 

This is an EPEL5 only package.

Steve.
Comment 6 Gwyn Ciesla 2012-07-16 11:07:51 EDT
Git done (by process-git-requests).
Comment 7 Fedora Update System 2012-07-16 13:29:06 EDT
python26-cheetah-2.4.4-3.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/python26-cheetah-2.4.4-3.el5
Comment 8 Fedora Update System 2012-07-19 18:38:37 EDT
python26-cheetah-2.4.4-3.el5 has been pushed to the Fedora EPEL 5 testing repository.
Comment 9 Fedora Update System 2012-08-05 02:41:07 EDT
python26-cheetah-2.4.4-3.el5 has been pushed to the Fedora EPEL 5 stable repository.

Note You need to log in before you can comment on or make changes to this bug.